<?php
namespace Models;

// Модель для работы с API
class Api extends Controller {
	public $service, $api_domen, $api_pass, $api_store_id, $api_count, $web;

	public function __construct($f3, $api_domen, $api_pass, $api_store_id, $api_count) {
		parent::__construct($f3);
		$this->api_store_id=$api_store_id;
		$this->api_domen=$api_domen;
		$this->api_pass=$api_pass;
		$this->api_count=$api_count;
		$this->web=\Web::instance();
	}

	// Получаем методы оплаты
	function paymentmethods() {
		$query=$this->api_domen.'/api/paymentmethods?token='.$this->api_pass;
		$json=$this->web->request($query);
		return json_decode($json['body'], true);
	}

	// Получаем пользователей
	function users() {
		$query=$this->api_domen.'/api/users?token='.$this->api_pass.'&store='.$this->api_store_id;
		$json=$this->web->request($query);
		if(mb_strpos($json['headers'][0], '200 OK')>0) {
			return json_decode($json['body'], true);
		}
		echo $json['error'];
		exit();
	}

	// получаем товары
	function products($time_update) {
		$query=$this->api_domen.'/api/get?token='.$this->api_pass.'&store='.$this->api_store_id.'&limit='.$this->api_count.'&time='.$time_update;
		$json=$this->web->request($query);
		if(mb_strpos($json['headers'][0], '200 OK')>0) {
			return json_decode($json['body'], true);
		}
		echo $json['error'];
		exit();
	}

	// Выгружаем чеки
	function tickets($tickets) {
		$vars=array(
			'token'=>$this->api_pass,
			'tickets'=>json_encode($tickets)
		);
		$options = array(
    		'method'  => 'POST',
    		'content' => http_build_query($vars),
		);
		$url=$this->api_domen.'/api/tickets';
		$json=$this->web->request($url, $options);
		if(!mb_strpos($json['headers'][1],'200 OK')) {
			echo $json['error'];
			exit();
		}
		return json_decode($json['body'], true);
	}

	// Получаем СНО
	function sno() {
		$query=$this->api_domen.'/api/sno?token='.$this->api_pass;
		$json=$this->web->request($query);
		return json_decode($json['body'], true);
	}
}